package gregapi.block.prefixblock;

import static gregapi.data.CS.NW_API;
import static gregapi.data.CS.W;
import gregapi.network.PacketExtendedMetaData;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.tileentity.TileEntityBase1;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.Packet;

/**
 * @author Gregorius Techneticies
 */
public class PrefixBlockTileEntity extends TileEntityBase1 implements IRenderedBlockObject {
	public short mMetaData = W;
	public boolean mBlocked = true;
	
	public PrefixBlockTileEntity() {super(false);}
	
    @Override
    public void onAdjacentBlockChange(int aX, int aY, int aZ) {
    	if (!worldObj.isRemote && mBlocked) {
    		mBlocked = false;
    		NW_API.sendToAllPlayersInRange(new PacketExtendedMetaData(xCoord, yCoord, zCoord, mMetaData), worldObj, xCoord, zCoord);
    	}
    }
    
	@Override
    public Packet getDescriptionPacket() {
		if (!worldObj.isRemote && !(mBlocked = UT.Worlds.isBlockOccluded(worldObj, xCoord, yCoord, zCoord))) {
			NW_API.sendToAllPlayersInRange(new PacketExtendedMetaData(xCoord, yCoord, zCoord, mMetaData), worldObj, xCoord, zCoord);
		}
		return null;
    }
	
	@Override
	public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide) {
		if (aBlock instanceof PrefixBlock) {
			((PrefixBlock)aBlock).IS_RENDERING_IN_WORLD = true;
			ITexture rTexture = ((PrefixBlock)aBlock).getTexture(aRenderPass, aSide, mMetaData);
			((PrefixBlock)aBlock).IS_RENDERING_IN_WORLD = false;
			return rTexture;
		}
		return null;
	}
	
	@Override public boolean setBlockBounds(Block aBlock, int aRenderPass, byte aSide) {return false;}
	@Override public int getRenderPasses(Block aBlock, byte aSide) {return 1;}
	@Override public String getModID() {Block tBlock = getBlockOffset(0, 0, 0); return tBlock instanceof PrefixBlock ? ((PrefixBlock)tBlock).mModIDOwner : "";}
	@Override public void readFromNBT(NBTTagCompound aNBT) {super.readFromNBT(aNBT); mMetaData = aNBT.getShort("m");}
    @Override public void writeToNBT(NBTTagCompound aNBT) {super.writeToNBT(aNBT); aNBT.setShort("m", mMetaData);}
}